"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  Auth: () => Auth,
  auth: () => auth
});
module.exports = __toCommonJS(src_exports);

// src/client/callbacks/signin.ts
var import_axios = __toESM(require("axios"));
function signInWithProvider(provider, config) {
  return __async(this, null, function* () {
    var _a;
    const { data: oauthUrlJson } = yield import_axios.default.get("/api/auth/signIn", {
      params: {
        provider
      },
      headers: __spreadValues({}, config),
      validateStatus: () => true
    });
    if (typeof window == "undefined")
      throw Error("signin should be ran client side");
    if (!oauthUrlJson.success) {
      return oauthUrlJson;
    } else if ((_a = oauthUrlJson.data) == null ? void 0 : _a.url) {
      window.location.href = oauthUrlJson.data.url;
      return false;
    } else {
      return oauthUrlJson;
    }
  });
}

// src/client/callbacks/signout.ts
function signOutAndReload() {
  return __async(this, null, function* () {
    yield fetch(`/api/auth/signOut`);
    if (typeof window !== "undefined") {
      window.location.reload();
    } else {
      throw new Error("This function can only be used on the client-side.");
    }
  });
}

// src/client/index.ts
var signIn = signInWithProvider;
var signOut = signOutAndReload;

// src/functions/auth.ts
var import_server_only = require("server-only");
var import_headers = require("next/headers");

// src/functions/jwt.ts
var import_jose = require("jose");
var import_buffer = require("buffer");
var privateKey;
var getPrivateKey = () => __async(void 0, null, function* () {
  return privateKey = privateKey || (yield (0, import_jose.importPKCS8)(import_buffer.Buffer.from(Auth.secret, "base64").toString("utf-8"), "RS256"));
});
var decodeToken = (sessionTokenString) => __async(void 0, null, function* () {
  try {
    const privateKey2 = yield getPrivateKey();
    return yield (0, import_jose.jwtVerify)(sessionTokenString, privateKey2);
  } catch (e) {
    return false;
  }
});

// src/functions/auth.ts
function sessionsInternal() {
  return __async(this, null, function* () {
    var _a;
    const cookie = (0, import_headers.cookies)();
    const sessionTokenString = (_a = cookie.get("SessionToken")) == null ? void 0 : _a.value;
    if (!sessionTokenString)
      return false;
    try {
      const decodedPayload = yield decodeToken(sessionTokenString);
      if (!decodedPayload || !decodedPayload.payload || !decodedPayload.payload.provider)
        return false;
      const currentProvider = Auth.config[decodedPayload.payload.provider];
      return currentProvider.provider.handleAuthCheck(sessionTokenString);
    } catch (e) {
      console.log(e);
      return false;
    }
  });
}

// src/functions/responces.ts
var sendError = (status, message) => {
  return Response.json({
    success: false,
    status,
    message
  }, {
    status,
    statusText: message
  });
};
var sendErrorRedirect = (status, message) => {
  return Response.redirect(`${process.env.NEXTAUTH_URL}/api/auth/error?message=${message}&code=${status}`, 302);
};

// src/routes/callback/[id]/route.ts
function GET(_0, _1) {
  return __async(this, arguments, function* (request, { params }) {
    const key = Object.keys(params)[0];
    if (!params[key].at(-1))
      return sendErrorRedirect(500, "this provider is not implemented");
    const authProvider = Auth.config[params[key].at(-1)];
    return authProvider.provider.handleCallback(request);
  });
}

// src/routes/signIn/route.ts
function GET2(request) {
  return __async(this, null, function* () {
    console.log("signing in");
    const searchParams = request.nextUrl.searchParams;
    const provider = searchParams.get("provider");
    const referer = request.headers.get("redirect_url") || request.headers.get("referer") || "/";
    if (!provider)
      return sendError(400, "please provide a ?provider");
    const providerData = Auth.config[provider];
    if (!providerData)
      return sendError(400, `Provider ${provider} is not supported.`);
    return providerData.provider.handleSignIn(request, referer);
  });
}

// src/routes/signOut/route.ts
var import_headers2 = require("next/headers");
function GET3() {
  return __async(this, null, function* () {
    const cookieHandler = (0, import_headers2.cookies)();
    cookieHandler.delete("SessionToken");
    return new Response();
  });
}

// src/routes/message/route.ts
function GET4(request) {
  return __async(this, null, function* () {
    console.log("signing in");
    const searchParams = request.nextUrl.searchParams;
    const message = searchParams.get("message");
    const code = searchParams.get("code");
    return new Response(`<!DOCTYPE html>
<html>
<head>
    <style>
        body {
            background-color: black;
            color: white;
        }
    </style>
</head>
<body>
    <h1>Message: </h1>
    <p id="message">${message}</p>

    <h1>Code: </h1>
    <p id="code">${code}</p>
</body>
</html>`, {
      headers: { "Content-Type": "text/html" }
    });
  });
}

// src/routes/error/route.ts
function GET5(request) {
  return __async(this, null, function* () {
    console.log("signing in");
    const searchParams = request.nextUrl.searchParams;
    const message = searchParams.get("message");
    const code = searchParams.get("code");
    return new Response(`<!DOCTYPE html>
<html>
<head>
    <style>
        body {
            background-color: black;
            color: white;
        }
    </style>
</head>
<body>
    <h1>Message: </h1>
    <p id="message">${message}</p>

    <h1>Code: </h1>
    <p id="code">${code}</p>
</body>
</html>`, {
      headers: { "Content-Type": "text/html" }
    });
  });
}

// src/routes/route.ts
var import_next_connect = require("next-connect");
var handler = (0, import_next_connect.createEdgeRouter)();
handler.get("/api/auth/callback/:id", GET);
handler.get("/api/auth/signOut", GET3);
handler.get("/api/auth/signIn", GET2);
handler.get("/api/auth/message", GET4);
handler.get("/api/auth/error", GET5);
function GET6(request, ctx) {
  return __async(this, null, function* () {
    console.log(request.nextUrl);
    return handler.run(request, ctx);
  });
}

// src/index.ts
var Auth = class _Auth {
  constructor(config, secret) {
    _Auth.config = config;
    _Auth.secret = secret;
    _Auth.components = {
      signIn,
      signOut
    };
    _Auth.routes = { GET: GET6 };
  }
};
var auth = sessionsInternal;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  Auth,
  auth
});
//# sourceMappingURL=index.js.map